unit Dem;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ToolWin, Menus, ExtCtrls, Buttons, StdCtrls, CPButton,ExtDlgs,
  Mask, Plab, AppEvnts, ActnList, ImgList,Pltypes;

type
  TForma1 = class(TForm)
    OpenPictureDialog1: TOpenPictureDialog;
    ColorDialog1: TColorDialog;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    StatusBar1: TStatusBar;
    ActionList1: TActionList;
    ImageList1: TImageList;
    FileNew: TAction;
    FileOpen: TAction;
    FileSave: TAction;
    FileSaveAs: TAction;
    FileExit: TAction;
    FilePrint: TAction;
    MainMenu1: TMainMenu;
    Archivo1: TMenuItem;
    Nuevo1: TMenuItem;
    Abrir1: TMenuItem;
    Guardar1: TMenuItem;
    GuardarComo1: TMenuItem;
    N1: TMenuItem;
    Imprimir1: TMenuItem;
    N2: TMenuItem;
    Salir1: TMenuItem;
    InsertText: TAction;
    InsertLine: TAction;
    InsertBarCode: TAction;
    Insertar1: TMenuItem;
    Texto1: TMenuItem;
    Linea3: TMenuItem;
    CodigoBarras1: TMenuItem;
    InsertImage: TAction;
    PropBack: TAction;
    PropPrint: TAction;
    Propiedades1: TMenuItem;
    Rejilla1: TMenuItem;
    ImagenFondo1: TMenuItem;
    MargenesImpresin1: TMenuItem;
    PropData: TAction;
    N4: TMenuItem;
    BaseDatos1: TMenuItem;
    Zoom1: TMenuItem;
    N501: TMenuItem;
    N751: TMenuItem;
    N1001: TMenuItem;
    N1251: TMenuItem;
    N1501: TMenuItem;
    N1751: TMenuItem;
    N2001: TMenuItem;
    ToolBar1: TToolBar;
    TBFileNew: TToolButton;
    TBFileOpen: TToolButton;
    TBFileSave: TToolButton;
    TBFileExit: TToolButton;
    TBFilePrint: TToolButton;
    ToolButton7: TToolButton;
    Selection: TAction;
    Delete: TAction;
    FileClose: TAction;
    Cerrar1: TMenuItem;
    PropiedadesImpresin1: TMenuItem;
    PrintDialog1: TPrintDialog;
    Smbolo1: TMenuItem;
    InsertSimbol: TAction;
    InsertAdTxt: TAction;
    TextoCompuesto1: TMenuItem;
    Rectngulo1: TMenuItem;
    Imagen1: TMenuItem;
    PLLab1: TPLLab;
    InsertPar: TAction;
    InsertRect: TAction;
    Prrafo1: TMenuItem;
    PropDim: TAction;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    TBFilePreview: TToolButton;
    FilePreview: TAction;
    Previsualizar1: TMenuItem;
    procedure VerEtiqueta(visible:boolean);
    procedure ActivaSeleccion(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Imprimir1Click(Sender: TObject);
    procedure FileExitExecute(Sender: TObject);
    procedure InsertTextExecute(Sender: TObject);
    procedure InsertLineExecute(Sender: TObject);
    procedure InsertBarCodeExecute(Sender: TObject);
    procedure GridExecute(Sender: TObject);
    procedure PropDataExecute(Sender: TObject);
    procedure FileNewExecute(Sender: TObject);
    procedure SelectionExecute(Sender: TObject);
    procedure PlLab1RightMouse(Sender: TObject);
    procedure FileSaveAsExecute(Sender: TObject);
    procedure FileSaveExecute(Sender: TObject);
    procedure FileOpenExecute(Sender: TObject);
    procedure N501Click(Sender: TObject);
    procedure N1001Click(Sender: TObject);
    procedure N1251Click(Sender: TObject);
    procedure N1501Click(Sender: TObject);
    procedure N1751Click(Sender: TObject);
    procedure N2001Click(Sender: TObject);
    procedure N751Click(Sender: TObject);
    procedure FileCloseExecute(Sender: TObject);
    procedure FilePrintExecute(Sender: TObject);
    procedure PlLab1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PrintExecute(Sender: TObject);
    procedure PropBackExecute(Sender: TObject);
    procedure PlLab1DblClick(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure InsertSimbolExecute(Sender: TObject);
    procedure InsertAdTxtExecute(Sender: TObject);
    procedure PropPrintExecute(Sender: TObject);
    procedure PropDimExecute(Sender: TObject);
    procedure InsertRectExecute(Sender: TObject);
    procedure InsertParExecute(Sender: TObject);
    procedure ToolButton13Click(Sender: TObject);
    procedure InsertImageExecute(Sender: TObject);
    procedure DeleteExecute(Sender: TObject);
    procedure ToolButton14Click(Sender: TObject);
    procedure FilePreviewExecute(Sender: TObject);
  private
    Modified: Boolean;
  public
    FileName: string;
    Ruta: string;
    function SaveChanges: Boolean;
    function Save: Boolean;
    function SaveAs: Boolean;
  end;

var
  Forma1: TForma1;

implementation

{$R *.DFM}

procedure TForma1.FormCreate(Sender: TObject);
begin
 FileName:= '';
 Modified:= false;
 VerEtiqueta(false);
 Ruta:= ExtractFilePath(Application.ExeName);
 StatusBar1.DoubleBuffered:= true;
end;

procedure TForma1.Imprimir1Click(Sender: TObject);
begin
 if PrinterSetupDialog1.Execute then
  begin
   PlLab1.Print;
  end;
end;

function TForma1.SaveChanges: Boolean;
begin
 case MessageDlg('La etiqueta '+FileName+' ha cambiado.'+#13#13+'Desea conservar los cambios?',
      mtConfirmation, mbYesNoCancel,0) of
      idYes: Result:= Save;
      idNo : Result:= True;
     else
      Result:= False;
 end;
end;

function TForma1.Save: Boolean;
begin
 if FileName = 'Untitled.eti' then
  Result:= SaveAs
 else
 begin
  PlLab1.SaveLab(FileName);
  Modified:= false;
  result:= true;
 end;
end;

function TForma1.SaveAs: Boolean;
begin
 SaveDialog1.FileName:= FileName;
 if SaveDialog1.Execute then
  begin
   FileName:= SaveDialog1.FileName;
   Save;
   result:= true;
  end
  else
   result:= false;
end;

procedure TForma1.VerEtiqueta(visible:boolean);
begin
 if visible then
  begin
   PlLab1.Visible:= true;
  end
  else
  begin
   PlLab1.Visible:= false;
  end;
end;

procedure TForma1.FileExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TForma1.InsertTextExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crCross;
 PlLab1.DrawTool:= dwText;
 Modified:= true;
end;

procedure TForma1.InsertLineExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crCross;
 PlLab1.DrawTool:= dwLine;
 Modified:= true;
end;

procedure TForma1.InsertBarCodeExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crCross;
 PlLab1.DrawTool:= dwBarCode;
 Modified:= true;
end;

procedure TForma1.GridExecute(Sender: TObject);
begin
 PlLab1.ShowProp(0);
 Modified:= true;
end;

procedure TForma1.FileNewExecute(Sender: TObject);
begin
 if not Modified or SaveChanges then
  begin
   Modified:= false;
   FileName:= 'Untitled.eti';
   PlLab1.CreateLab;
   StatusBar1.Panels[1].Text:= '  '+FileName;
   VerEtiqueta(true);
   Guardar1.Enabled:= true;
   GuardarComo1.Enabled:= true;
   Imprimir1.Enabled:= true;
   Previsualizar1.Enabled:= true;
   PropiedadesImpresin1.Enabled:= true;
   Cerrar1.Enabled:= true;
   Nuevo1.Enabled:= false;
   Abrir1.Enabled:= false;
   TBFileNew.Enabled:= false;
   TBFileOpen.Enabled:= false;
   TBFileSave.Enabled:= true;
   TBFilePrint.Enabled:= true;
   TBFilePreview.Enabled:= true;
  end;
end;

procedure TForma1.SelectionExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crDefault;
 PlLab1.DrawTool:= dwSelection;
end;

procedure TForma1.PlLab1RightMouse(Sender: TObject);
begin
 SelectionExecute(Self);
 ToolButton1.Down:= true;
end;

procedure TForma1.FileSaveAsExecute(Sender: TObject);
begin
  SaveAs;
end;

procedure TForma1.FileSaveExecute(Sender: TObject);
begin
 if Modified then Save;
end;

procedure TForma1.FileOpenExecute(Sender: TObject);
begin
 if not Modified or SaveChanges then
 begin
  if OpenDialog1.Execute then
   begin
    FileName:= OpenDialog1.FileName;
    PlLab1.LoadLab(FileName);
    Modified:= false;
    N1001.Checked:= true;
    PlLab1.Zoom:= zm100;
    VerEtiqueta(true);
    Guardar1.Enabled:= true;
    GuardarComo1.Enabled:= true;
    Imprimir1.Enabled:= true;
    Previsualizar1.Enabled:= true;
    PropiedadesImpresin1.Enabled:= true;
    Cerrar1.Enabled:= true;
    Nuevo1.Enabled:= false;
    Abrir1.Enabled:= false;
    TBFileNew.Enabled:= false;
    TBFileOpen.Enabled:= false;
    TBFileSave.Enabled:= true;
    TBFilePrint.Enabled:= true;
    TBFilePreview.Enabled:= true;
    StatusBar1.Panels[1].Text:= '  '+FileName;
   end;
 end;
end;

procedure TForma1.FileCloseExecute(Sender: TObject);
begin
if not Modified or SaveChanges then
 begin
  PlLab1.Clear;
  Guardar1.Enabled:= false;
  GuardarComo1.Enabled:= false;
  Imprimir1.Enabled:= false;
  Previsualizar1.Enabled:= false;
  PropiedadesImpresin1.Enabled:= false;
  Cerrar1.Enabled:= false;
  Nuevo1.Enabled:= true;
  Abrir1.Enabled:= true;
  TBFileNew.Enabled:= true;
  TBFileOpen.Enabled:= true;
  TBFileSave.Enabled:= false;
  TBFilePrint.Enabled:= false;
  TBFilePreview.Enabled:= false;
  PlLab1.BackSurf.Style:= biNone;
  //PlLab1.BackSurf.FileName:= '';
  VerEtiqueta(false);
 end;
end;

procedure TForma1.N501Click(Sender: TObject);
begin
 N501.Checked:= true;
 PlLab1.Zoom:= zm50;
end;

procedure TForma1.N751Click(Sender: TObject);
begin
 N751.Checked:= true;
 PlLab1.Zoom:= zm75;
end;

procedure TForma1.N1001Click(Sender: TObject);
begin
 N1001.Checked:= true;
 PlLab1.Zoom:= zm100;
end;

procedure TForma1.N1251Click(Sender: TObject);
begin
 N1251.Checked:= true;
 PlLab1.Zoom:= zm125;
end;

procedure TForma1.N1501Click(Sender: TObject);
begin
 N1501.Checked:= true;
 PlLab1.Zoom:= zm150;
end;

procedure TForma1.N1751Click(Sender: TObject);
begin
 N1751.Checked:= true;
 PlLab1.Zoom:= zm175;
end;

procedure TForma1.N2001Click(Sender: TObject);
begin
 N2001.Checked:= true;
 PlLab1.Zoom:= zm200;
end;

procedure TForma1.FilePrintExecute(Sender: TObject);
begin
 if PrintDialog1.Execute then
  begin
   PlLab1.Print;
  end;
end;

procedure TForma1.ActivaSeleccion(Sender: TObject);
begin
 SelectionExecute(Self);
 ToolButton1.Down:= true;
end;

procedure TForma1.PlLab1MouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
begin
 StatusBar1.Panels[0].Text:= ' X: '+ FloatToStrF(PlLab1.Worldx(X),ffFixed,4,2)+'  Y: '+ FloatToStrF(PlLab1.Worldy(Y),ffFixed,4,2);
end;

procedure TForma1.PrintExecute(Sender: TObject);
begin
 PlLab1.ShowProp(1);
end;

procedure TForma1.PropBackExecute(Sender: TObject);
begin
 PlLab1.ShowProp(2);
end;

procedure TForma1.PlLab1DblClick(Sender: TObject);
begin
 Modified:= true;
end;

procedure TForma1.ToolButton1Click(Sender: TObject);
begin
 PlLab1.Cursor:= crCross;
 PlLab1.DrawTool:= dwRect;
 Modified:= true;
end;

procedure TForma1.InsertSimbolExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crCross;
 PlLab1.DrawTool:= dwSymbol;
 Modified:= true;
end;

procedure TForma1.InsertAdTxtExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crCross;
 PlLab1.DrawTool:= dwAddText;
 Modified:= true;
end;

procedure TForma1.InsertRectExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crCross;
 PlLab1.DrawTool:= dwRect;
 Modified:= true;
end;

procedure TForma1.InsertParExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crCross;
 PlLab1.DrawTool:= dwParagraph;
 Modified:= true;
end;

procedure TForma1.InsertImageExecute(Sender: TObject);
begin
 PlLab1.Cursor:= crCross;
 PlLab1.DrawTool:= dwImage;
 Modified:= true
end;

procedure TForma1.PropPrintExecute(Sender: TObject);
begin
 PlLab1.ShowProp(1);
end;

procedure TForma1.PropDataExecute(Sender: TObject);
begin
 PlLab1.ShowProp(3);
end;

procedure TForma1.PropDimExecute(Sender: TObject);
begin
 PlLab1.ShowProp(0);
end;

procedure TForma1.ToolButton13Click(Sender: TObject);
begin
 PlLab1.ShowProp(0);
end;

procedure TForma1.DeleteExecute(Sender: TObject);
begin
 PlLab1.DeleteElement(Sender);
end;

procedure TForma1.ToolButton14Click(Sender: TObject);
begin
 ShowMessage(IntToStr(PlLab1.PrintInfo.Labs));
end;

procedure TForma1.FilePreviewExecute(Sender: TObject);
begin
 PlLab1.Preview;
end;

end.


